/*
----------------------------------
Creator: Haturbokmuffer-studios
Youtube: Haturbok muffer
Discord: Haturbokmuffer#7383

Credits: Unknown pro9243 / Disc: player_123/unknown_pro#8005 / YT: Itruelysuckgood
----------------------------------
*/

import { world } from "@minecraft/server";
import { rankDefault } from "./configuration.js";
import { rankPrefix } from "./configuration.js";
import { clanDefault } from "./configuration.js";
import { clanPrefix } from "./configuration.js";

const RANK_PREFIX = `${rankPrefix}`;
const DEFAULT_RANK = `${rankDefault}`;
const CLAN_PREFIX = `${clanPrefix}`;
const DEFAULT_CLAN = `${clanDefault}`;

function getRanks(player) {
    const ranks = player
        .getTags()
        .map((v) => {
            if (!v.startsWith(RANK_PREFIX)) return null;
            return v.substring(RANK_PREFIX.length);
        })
        .filter((x) => x);
    return ranks.length === 0 ? [DEFAULT_RANK] : ranks;
}

function getClans(player) {
    const clans = player
        .getTags()
        .map((v) => {
            if (!v.startsWith(CLAN_PREFIX)) return null;
            return v.substring(CLAN_PREFIX.length);
        })
        .filter((x) => x);
    return clans.length === 0 ? [DEFAULT_CLAN] : clans;
}

function getColorizedRank(rank) {
    const rankColor = rank !== DEFAULT_RANK ? rank.substring(0, 2) : "§7";
    const bracketColor = rankColor !== "§7" ? rankColor : "§r";
    return `${bracketColor}[${rankColor}${rank}${bracketColor}]§r`;
}

function getColorizedClan(clan) {
    const clanColor = clan !== DEFAULT_CLAN ? clan.substring(0, 2) : "§7";
    const bracketColor = clanColor !== "§7" ? clanColor : "§r";
    return `${bracketColor}[${clanColor}${clan}${bracketColor}]§r`;
}

world.beforeEvents.chatSend.subscribe((data) => {
    data.sendToTargets = true;
    data.targets = [];
    const ranks = getRanks(data.sender).join("§r§8] [§r");
    const clans = getClans(data.sender).join("§r§8] [§r");
    const message = data.message;
    let player = data.sender;
    if (!player.hasTag("mute")) {
        const rank = ranks !== DEFAULT_RANK ? ranks : "";
        const formattedRank = rank ? getColorizedRank(rank) : "";
        const playerNameColor = rank ? rank.substring(0, 2) : "§7";
        const playerName = ranks !== DEFAULT_RANK ? `${playerNameColor} ${player.name}§r` : `§7${player.name}§r`;
        const formattedClans = getColorizedClan(clans);
        world.sendMessage(`§r${formattedClans} ${formattedRank}${playerName} §7§l>§r ${message}`);
    } else if (player.hasTag("mute")) {
        player.sendMessage("§g§l[§r§4§k..§r§b§lServer§r§4§k..§r§g§l] §7>> §cYou Can't Send Messages Because You're Muted!");
    }
});
